<?php
/**
* Google Sitemap Generator  - A Joomla/Mambo Component
* @version 2.0.2
* @package Emptorum.com
* @copyright (C) 2005 by rg66
* @license Released under the terms of the GNU General Public License
**/

// no direct access
defined('_VALID_MOS') or die('Restricted access');

/**
* @package GSG
* @subpackage Config
* Functions taken from the com_config
*/
class gsgConfig {
	// Site Settings
	/** @var string */
	var $gsg_filename = null;
	/** @var int */
	var $gsg_url_lastmod = 0;
	/** @var string */
	var $gsg_url_changefreq = null;
	/** @var string */
	var $gsg_url_priority = null;
	/** @var string */
	var $gsg_menus = null;
	/** @var int */
	var $gsg_ping = 0;
	/** @var string */
	var $gsg_location = null;
	/** @var int */
	var $gsg_displayedit = 0;

	//Plugin Settings
	/** @var int */
	var $gsg_plugin = 1;

	//Module Settings
	/** @var int */
	var $gsg_module_hours = 0;
	/** @var int */
	var $gsg_module_on = 0;

	/**
	 * @return array An array of the public vars in the class
	 */
	function getPublicVars() {
		$public = array ();
		$vars = array_keys(get_class_vars(get_class($this)));
		sort($vars);
		foreach ($vars as $v) {
			if ($v {
				0 }
			!= '_') {
				$public[] = $v;
			}
		}
		return $public;
	}

	/**
	 *	binds a named array/hash to this object
	 *	@param array $hash named array
	 *	@return null|string	null is operation was satisfactory, otherwise returns an error
	 */
	function bind($array, $ignore = '') {
		if (!is_array($array)) {
			$this->_error = strtolower(get_class($this)).'::bind failed.';
			return false;
		} else {
			return mosBindArrayToObject($array, $this, $ignore);
		}
	}

	/**
	 * Writes the configuration file line for a particular variable
	 * @return string
	 */
	function getVarText() {
		$txt = '';
		$vars = $this->getPublicVars();
		foreach ($vars as $v) {
			$k = str_replace('config_', 'mosConfig_', $v);
			$txt .= "\$$k = '".addslashes($this-> $v)."';\n";
		}
		return $txt;
	}

	/**
	 * Binds the global configuration variables to the class properties
	 */
	function bindGlobals() {
		$vars = $this->getPublicVars();
		foreach ($vars as $v) {
			$k = str_replace('config_', 'mosConfig_', $v);
			if (isset ($GLOBALS[$k]))
				$this-> $v = $GLOBALS[$k];
		}
	}

}

/**
*
* Class for the table gsgconfig
*/

class gsgconfig2 extends mosDBTable {
	// Site Settings
	/** @var int */
	var $id = null;
	/** @var varchr */
	var $classname = null;
	/** @var tinyint */
	var $enabled = null;

	function gsgconfig2(& $db) {
		$this->mosDBTable('#__gsgconfig', 'id', $db);
	}
}

/**
 * 
 * @package GSG
 */

class gsg {

	/**
	* Generate the XML File
	* @return Returns the first line of the XML header
	*/
	function gsg_header() {
		$xml_content = "<?xml version =\"1.0\" encoding=\"UTF-8\"?>\n";
		return $xml_content;
	}
	/**
	* Generate the XML File
	* @return Returns the starting definition for the second line
	*/
	function gsg_header2() {
		$xml_content = "  <urlset ";
		return $xml_content;
	}

	/**
	* Generate the XML File
	* @return Returns the starting definition for the second line if more then one sitemap have to be established
	*/
	function gsg_header2a() {
		$xml_content = "  <sitemapindex ";
		return $xml_content;
	}

	/**
	* Generate the XML File
	* @return Returns the second part for the secondline.  Is the same for gsg_header2 and gsg_header2_1
	*/
	function gsg_header3() {
		$xml_content = "xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\n";
		return $xml_content;
	}

	/**
	* Generate the XML File
	* @param $xml_url 	The Url which has to be shown
	* @param $xml_date	The date when the page has been stored/modified/created
	* @param $xml_freq	The frequency how often the url content is changing
	* @param $xml_priority	What priority to the web content does the file/url have
	* @return Returns the filled out section
	*/
	function gsg_url($xml_url, $xml_date, $xml_freq, $xml_priority) {
		$xml_content = "   <url>\n";
		$url = gsg :: xml_replace($xml_url);
		$xml_content .= "        <loc>".$url."</loc>\n";
		$xml_content .= "	<lastmod>".$xml_date."</lastmod>\n";
		$xml_content .= "        <changefreq>".$xml_freq."</changefreq>\n";
		$xml_content .= "	<priority>".$xml_priority."</priority>\n";
		$xml_content .= "   </url>\n";
		return $xml_content;
	}

	/**
	* Generate the XML File
	* @return Returns the footer if gsg_header2 has been used
	*/
	function gsg_footer() {
		$xml_content = "</urlset>";
		return $xml_content;
	}

	/**
	* Generate the XML File
	* @return Returns the footer if gsg_header2_1 has been used
	*/
	function gsg_footer2() {
		$xml_content = "  </sitemapindex>";
		return $xml_content;
	}

	/**
	* Generate the XML File
	* @param $xml_path	If more then one XML sitemaphas been stored the path to the files is listed
	* @param $xml_date	When has the sitemaps been created
	* @param $si		Indicates how many sitemaps have been installed
	* @return Returns the XML so that the user will be informed that another XML have been installed
	*/
	function gsg_sitemap($xml_path, $si) {
		global $mosConfig_live_site, $gsg_filename, $gsg_location;
		$slash = "";
		
		if (strlen($gsg_location)) {
			$slash = "/";
		}

		$gsg_path = $mosConfig_live_site."/".$gsg_location.$slash.$gsg_filename;
		for ($i = 1; $i <= $si; $i ++) {
			$xml_content .= "    <sitemap>\n";
			$xml_siteindex = $gsg_path.$i.".xml.gz";
			$xml_content .= "       <loc>".$xml_siteindex."</loc>\n";
			$xml_content .= "       <lastmod>".gsg::showdate(0,0,1)."</lastmod>\n";
			$xml_content .= "    </sitemap>\n";
		}
		//save the file now
		$xml_path = $xml_path."index.xml";
		$makefile = gsg :: gsg_makefile($xml_path, $xml_content, false, 1);

		return $makefile;
	}

	/**
	* Generate the SQL Statement to get the XML Url entries.
	* @param $table 	The table name within the Database
	* @param $id 		The id number from the individual record
	* @param $sectionid	The sectionid if it exists
	* @param $link		If a link is hardcoded
	* @param $published	Is the recoded published
	* @param $created 	When was the record created
	* @param $modified	When has it been modified
	* @param $menutype	Only to be used with the table #__menu
	* @return Returns the sql statement
	*/
	function gsg_sql($tablename, $id, $sectionid, $title, $link, $published, $created, $modified, $menutype) {

		$query = "SELECT $id, $sectionid, $title, $published, $created, $modified "."FROM #_".$tablename." WHERE $published = 1 ";
		return $query;

	}

	/**
	* Generate the XML File
	* @param $xml_url	Characters are searched for ans replaced within the file
	* @return Returns the Url with Characters Google will accept
	*/
	function xml_replace($xml_url) {
		$look_for = array ("&", "'", "\"", ">", "<");
		$change_to = array ("&amp;", "&apos;", "&quot;", "&gt;", "&lt;");
		$newurl = str_replace($look_for, $change_to, $xml_url);
		return $newurl;
	}

	/**
	* Function from php.net
	* @param $source	The source file which should be gzipped
	* @param $level		False no gzip, True gzip will be used
	*/
	function gzcompressfile($source, $level = false) {
		$dest = $source.'.gz';
		$mode = 'wb'.$level;
		$error = false;
		if ($fp_out = gzopen($dest, $mode)) {
			if ($fp_in = fopen($source, 'rb')) {
				while (!feof($fp_in))
					gzwrite($fp_out, fread($fp_in, 1024 * 512));
				fclose($fp_in);
			} else
				$error = true;
			gzclose($fp_out);
		} else
			$error = true;
		if ($error)
			return false;
		else
			return $dest;
	}

	/**
	* Generate the XML File
	* @param $xmlfile	The xml file is generated 
	* @param $xml_content	The content which has to be included within the file
	* @param $gzip		True to use gzip
	* @param $type 		either sitemap when true or urlset when false
	* @return Returns the full content of the XML file
	*/
	function gsg_makefile($xmlfile, $xml_content, $gzip = true, $type) {
		if ($gzip) {
			//make the file
			$content = gsg :: gsg_header();
			$content .= gsg :: gsg_header2().gsg :: gsg_header3();
			$content .= $xml_content;
			$content .= gsg :: gsg_footer();
			if ($fp = fopen($xmlfile, "w")){
				fputs($fp, $content, strlen($content));
				fclose($fp);
			}
			//call gzcopressfile
			gsg :: gzcompressfile($xmlfile, true);
			//delete the file
			unlink($xmlfile);
		} else {
			if ($fp = fopen($xmlfile, "w")) {
				$content = gsg :: gsg_header();
				if ($type){
					$content .= gsg :: gsg_header2a().gsg :: gsg_header3();
				} else {
				        $content .= gsg :: gsg_header2().gsg :: gsg_header3();
				}
				$content .= $xml_content;
				if ($type){
					$content .= gsg :: gsg_footer2();
				} else {
					$content .= gsg :: gsg_footer();
				}
				fputs($fp, $content, strlen($content));
				fclose($fp);
			}
			return $content;
		}
	}

	function gsg_rename() {
	}

	function gsg_deletefile() {
	}

	function gsg_deletefolder() {
	}

	function gsg_make_sitemap_index($xmlfile, $si_counter) {
	}

	/**
	* Generate the XML File
	* param $xmlfile	Change the chmod for what file
	*/
	function gsg_chmod($xmlfile) {
		@ chmod($xmlfile, 0766);
	}

	/**
	* Generate the XML File
	* @param $xmlfile	Is the xmlfile writable
	* @param $msg		Show $msg
	*/
	function gsg_iswriteable($xmlfile, $msg) {
		$permission = is_writable($xmlfile);
		if (!$permission) {
			mosRedirect("index2.php?option=$option&task=config", $msg);
			break;
		}
	}

	/**
	* Generate the Date with the format Google whats it
	* @param $created 	The date in the databse when the item has been created
	* @param $modified	The date when an item has been modified
	* @param $param		If True use $created day, otherwise $modified
	* return Returns the date
	*/
	function showdate($created, $modified, $param) {
		if ($param) {
			$datetoshow = mosCurrentDate($format = "%Y-%m-%dT%H:%M:%S+00:00");
			return $datetoshow;
		} else {
			if ($modified == "0000-00-00 00:00:00") {
				$datetoshow = mosFormatDate($created, $format = "%Y-%m-%dT%H:%M:%S+00:00", $offset = "");
			} else {
				$datetoshow = mosFormatDate($modified, $format = "%Y-%m-%dT%H:%M:%S+00:00", $offset = "");
			}
			return $datetoshow;
		}
	}

	/**
	* Pings to Google
	* @param $count 	Defines if only one sitemap or more have been generated
	* @return returns the msg from Google
	*/
	function gsg_ping($count) {
		global $gsg_ping,$mosConfig_live_site,$gsg_location,$gsg_filename ;
		$gsg_msg = "";
		if ($gsg_ping) {
			//We notify googles with the new sitemap
			if ($count==1){
				$gsg_xml_location = $mosConfig_live_site."/".$gsg_location.$gsg_filename.".xml";
			} else {
				$gsg_xml_location = $mosConfig_live_site."/".$gsg_location.$gsg_filename."index.xml";
			}
			//echo $gsg_xml_location;
			$handle = fopen("http://www.google.com/webmasters/sitemaps/ping?sitemap=".urlencode($gsg_xml_location), "r");
			if ($handle) {
				$string = fread($handle, 4096000);
				//$gsg_msg = _gsg_ping_ok;
				$gsg_msg = $string;
			} else {
				$gsg_msg = _gsg_ping_error;
			}
			fclose($handle);
			
		}

		return $gsg_msg;
	}

	/**
	* Get the urls and then call up the function xml
	* param $option
	* param $frontend	Is the script called from the frontend =True or Backend = False
	*/
	function geturl($option, $frontend) {
		global $database, $mosConfig_absolute_path, $mosConfig_live_site;
		require ($mosConfig_absolute_path."/administrator/components/com_gsg/gsg.config.php");
		//require_once($mosConfig_absolute_path.'/includes/sef.php');

		$results = gsg :: getPluginData();
 		
		for ($i = 0, $n = count($results); $i < $n; $i ++) {
			$row = & $results[$i];
			$xml_check[$i] = "ON";

			$link_content = $mosConfig_live_site."/".gsg :: sefRelToAbs($row->link);

			$xml_url[$i] = $link_content;
			$xml_date[$i] = $row->date;
			$xml_freq[$i] = $row->changeFreq;
			$xml_priority[$i] = $row->priority;
		}
		gsg :: xml($option, $i, $xml_check, "No Title", $xml_url, $xml_date, $xml_freq, $xml_priority, $frontend);

	}

	/**
	* Makes the XML File
	* @param $option
	* @param $xmlrows	How many rows or urls are there
	* @param $xml_check	Array-Only Urls which ares et to ON will be added to the XML File
	* @param $title		Array-Has no meaning but we have kept it
	* @param $xml_url	Array-The url which has to be displayed in the XML File. Will be SEF if needed
	* @param $xml_date	Array-The date when the url has been created or modified
	* @param $xml_freq	Array-What is the change frequency  of the url
	* @param $xml_priority	Array-What is the priority of the url towarsd the whole website
	* @param $frontend	Is the script run from the frontend=True or backend=False
	*
	*/
	function xml($option, $xml_rows, $xml_check, $xml_title, $xml_url, $xml_date, $xml_freq, $xml_priority, $frontend = false) {
		global $mosConfig_live_site, $mosConfig_absolute_path;
		require ($mosConfig_absolute_path."/administrator/components/com_gsg/gsg.config.php");

		// We hardcode the first base line
		$xml_content = gsg :: gsg_url($mosConfig_live_site, mosCurrentDate($format = "%Y-%m-%d"), $gsg_url_changefreq, $gsg_url_priority);

		//we delete all gzip files if they exists
		gsg::clean_gzip();
		
		//Establish a counter to copunt the Urls.  If over 50.000 then we generate the file
		$j = 0;
		$si = 1;

		//total file size of 2 Mb is 2097152 bytes.  So we need to make sure strlen of total file w/ opening and closing
		//tags is <= 2097152 bytes

		//vars for the file size

		//initial size w/ header and footer
		$initsize = strlen(gsg :: gsg_header());
		$initsize += strlen(gsg :: gsg_header2());
		$initsize += strlen(gsg :: gsg_header3());
		$initsize += strlen(gsg :: gsg_footer());

		$size = $initsize;
                
                set_time_limit(900);
                
                for ($i = 1; $i <= $xml_rows; $i ++) {
			if ($xml_check[$i] == "ON") {

				$j ++;
				$xml_content .= gsg :: gsg_url($xml_url[$i], $xml_date[$i], $xml_freq[$i], $xml_priority[$i]);
                                $xml_content_len = gsg :: gsg_url($xml_url[$i], $xml_date[$i], $xml_freq[$i], $xml_priority[$i]);
				$size += strlen($xml_content_len);
                                if ($j == 50000 || $size >= 2097152) {
					//Make the file
					$j = 0;
					$xmlfile = $mosConfig_absolute_path."/".$gsg_location.$gsg_filename.$si.".xml";
					$xml_content = gsg :: gsg_makefile($xmlfile, $xml_content, true, 0);
					//we increase the siteindex by one
					$si ++;
					$xml_content = "";

					//reset the size to include the header and footer
					$size = $initsize;
				}
			}
		}

		if ($si==1) {
			//Saving file
			$xmlfile = $mosConfig_absolute_path."/".$gsg_location.$gsg_filename.".xml";
			gsg :: gsg_chmod($xmlfile);
			$permission = gsg :: gsg_iswriteable($xmlfile, _gsg_xml_nowrite);
			$xml_content = gsg :: gsg_makefile($xmlfile, $xml_content, false, 0);
		} else {
			//we need to save the remaining urls in the next sitemap
			//we first check if the content is greater then 0
			if (strlen($xml_content) > 0){
				$xmlfile = $mosConfig_absolute_path."/".$gsg_location.$gsg_filename.$si.".xml";
				$xml_content = gsg :: gsg_makefile($xmlfile, $xml_content, true, 0);
			}
			//generate the sitemap_index file
			$xmlfile = $mosConfig_absolute_path."/".$gsg_location.$gsg_filename;
			$xml_content = gsg :: gsg_sitemap($xmlfile, $si);
		}

		//We ping to google if it is set in the config
		gsg :: gsg_ping($si);
                
		if($si==1){
			$gsg_xml_url = $mosConfig_live_site."/".$gsg_location.$gsg_filename;
		} else {
			$gsg_xml_url = $mosConfig_live_site."/".$gsg_location.$gsg_filename."index";
		}
		$gsg_url = urlencode($gsg_xml_url);

		if (!$frontend) {
			HTML_gsg :: xml($option, $xml_content, $xml_check, $gsg_filename, $gsg_msg, $gsg_url, $xml_rows);
		}
	}

	/**
	* Calls all plugins in the plugins to get urls.
	* @return  An array of URLResource objects
	*/
	function getPluginData() {
		global $database, $mosConfig_absolute_path;

		$ABSDIR = $mosConfig_absolute_path."/administrator/components/com_gsg";
		$PLUGINDIR = $ABSDIR."/plugins";

		//load the dir
		$dir = dir($PLUGINDIR);

		//load the URL object
		require_once ($ABSDIR."/urlresource.class.php");
		//load the extension object
		require_once ($ABSDIR."/gsgextension.class.php");

		//the resulting array
		$results = array ();

		while ($entry = $dir->read()) {

			//skip non class php files.
			if (!eregi(".+\.class\.php$", $entry)) {
				continue;
			} //end if

			//dynamically load class and call it

			//echo "entry = $entry\n";

			//require the file
			require_once ($PLUGINDIR."/".$entry);

			//get the class name from the entry.  According to php.net, explode is
			//faster and a regex call.
			$filename = explode(".", $entry, 2);

			//        echo "filename $filename[0]<br>";
			//        echo "sql: SELECT enabled from #__gsgconfig where classname = '". $filename[0]."'<br>";
			//query the DB.  TODO Can we index an array by classname before the loop?  This will inprove performance
			$database->setQuery("SELECT enabled from #__gsgconfig where classname = '".$filename[0]."'");
			$enabled = $database->loadResult();

			//now check it exists or it is enabled in the db, if it isn't skip it.
			if ($enabled) {
				$plugin = new $filename[0] ();

				//result array
				$results = array_merge($results, $plugin->getURLResources());
			}

		} //end while

		return $results;
		//    echo "results size = " . count($results);

	} //end get plugin data

	/**
	* Opens up a xml file and looks for the element 
	* @param $ElementName	Define what element you want to retrieve from the xml file
	* @param $Document	Define the document, can be http as well!
	* @return  Element Value
	*/
	function getXMLElementData($ElementName, $Document) {
		global $mosConfig_absolute_path;
		require_once ($mosConfig_absolute_path."/includes/domit/xml_domit_include.php");

		$gsgCollection = & new DOMIT_Document();
		$gsgCollection->resolveErrors(true);
		//$gsgCollection->useHTTPClient(true);
		$success = $gsgCollection->loadXML($Document);

		if ($success) {
			if ($gsgCollection->documentElement->hasChildNodes()) {
				$myChildNodes = & $gsgCollection->documentElement->childNodes;
				$numChildren = & $gsgCollection->documentElement->childCount;

				for ($i = 0; $i < $numChildren; $i ++) {
					$currentNode = & $myChildNodes[$i]->firstChild;
					$currentNodeName = & $myChildNodes[$i];
					if ($currentNodeName->nodeName == $ElementName) {
						return $currentNode->toString(false);
					}

				}
			}
		}
	}

	/**
	* Define the patTemplate function
	* @return patTemplate
	*/
	function & createTemplate() {
		global $option, $mosConfig_absolute_path;
		require_once ($mosConfig_absolute_path.'/includes/patTemplate/patTemplate.php');

		$tmpl = & patFactory :: createTemplate($option, true, false);
		$tmpl->setRoot(dirname(__FILE__).'/tmpl');

		return $tmpl;
	}

	function checkName($name) {
		$name = str_replace('../', '', $name);
		$name = str_replace('./', '', $name);
		return $name;
	}

	/**
	* used from sef.php
	* TODO.  When the include is fixed in sef, just include the
	* file and call the function
	*/
	function sefRelToAbs($string) {
		GLOBAL $mosConfig_live_site, $mosConfig_sef, $mosConfig_mbf_content;

		global $iso_client_lang;
		if ($mosConfig_mbf_content && $string != "index.php" && !eregi("^(([^:/?#]+):)", $string) && !strcasecmp(substr($string, 0, 9), "index.php") && !eregi("lang=", $string)) {
			$string .= "&lang=$iso_client_lang";
		}

		if ($mosConfig_sef && !eregi("^(([^:/?#]+):)", $string) && !strcasecmp(substr($string, 0, 9), "index.php")) {

			// Replace all &amp; with &
			$string = str_replace('&amp;', '&', $string);

			/*
			Home
			index.php
			*/
			if ($string == "index.php") {
				$string = "";
			}

			$sefstring = "";
			if ((eregi("option=com_content", $string) || eregi("option=content", $string)) && !eregi("task=new", $string) && !eregi("task=edit", $string)) {
				/*
				Content
				index.php?option=com_content&task=$task&sectionid=$sectionid&id=$id&Itemid=$Itemid&limit=$limit&limitstart=$limitstart
				*/
				$sefstring .= "content/";
				if (eregi("&task=", $string)) {
					$temp = split("&task=", $string);
					$temp = split("&", $temp[1]);
					$sefstring .= $temp[0]."/";
				}
				if (eregi("&sectionid=", $string)) {
					$temp = split("&sectionid=", $string);
					$temp = split("&", $temp[1]);
					$sefstring .= $temp[0]."/";
				}
				if (eregi("&id=", $string)) {
					$temp = split("&id=", $string);
					$temp = split("&", $temp[1]);
					$sefstring .= $temp[0]."/";
				}
				if (eregi("&Itemid=", $string)) {
					$temp = split("&Itemid=", $string);
					$temp = split("&", $temp[1]);
					$sefstring .= $temp[0]."/";
				}
				if (eregi("&limit=", $string)) {
					$temp = split("&limit=", $string);
					$temp = split("&", $temp[1]);
					$sefstring .= $temp[0]."/";
				}
				if (eregi("&limitstart=", $string)) {
					$temp = split("&limitstart=", $string);
					$temp = split("&", $temp[1]);
					$sefstring .= $temp[0]."/";
				}
				if (eregi("&lang=", $string)) {
					$temp = split("&lang=", $string);
					$temp = split("&", $temp[1]);
					$sefstring .= "lang,".$temp[0]."/";
				}
				$string = $sefstring;
			} else
				if (eregi("option=com_", $string) && !eregi("option=com_registration", $string) && !eregi("task=new", $string) && !eregi("task=edit", $string)) {
					/*
					Components
					index.php?option=com_xxxx&...
					*/
					$sefstring = "component/";
					$temp = split("\?", $string);
					$temp = split("&", $temp[1]);
					foreach ($temp as $key => $value) {
						$sefstring .= $value."/";
					}
					$string = str_replace('=', ',', $sefstring);
				}
			//echo $mosConfig_live_site."/".$string;
			return $mosConfig_live_site."/".$string;
		} else {
			return $string;
		}

	}

	/**
	 * Removes any files not in the database from the plugin dir
	 * @return int The number of files removed
	 */
	function cleanPlugins(){
		global $mosConfig_absolute_path, $database;
		
		$ABSDIR = $mosConfig_absolute_path."/administrator/components/com_gsg";
		$PLUGINDIR = $ABSDIR."/plugins";

		//load the dir
		$dir = dir($PLUGINDIR);
		$numRemoved = 0;
		
		while ($entry = $dir->read()) {
			
			//skip non class php files.
			if (!eregi(".+\.class\.php$", $entry)) {
				continue;
			} //end if

			//get the class name from the entry.  According to php.net, explode is
			//faster and a regex call.
			$filename = explode(".", $entry, 2);
			
			//select the count, we'll get 0 or greater.  If 0, delete it, if 1 leave it.  If > 1 something is not quite right
			$database->setQuery("SELECT count(classname) from #__gsgconfig where classname = '".$filename[0]."'");
			$count = $database->loadResult();
			
			//file exists but not in db. Delete it
			if($count == 0){
				unlink($PLUGINDIR."/".$entry);	
				$numRemoved++;		
			}	
		}//end while
		
		return $numRemoved;
		
	}
	
	/*
	* removes the gzip files before they are established
	* we do not want more space occupied then is required
	*/
	function clean_gzip(){
		global $mosConfig_absolute_path, $gsg_filename, $gsg_location;
		$slash = "";
		
		if (strlen($gsg_location)) {
			$slash = "/";
		}
		
		$gsg_path = $mosConfig_absolute_path.$slash.$gsg_location;
		
		//load the dir
		$dir = dir($gsg_path);
		while ($entry = $dir->read()) {
			if (eregi(".+\.xml\.gz$", $entry)) {
				unlink($gsg_path."/".$entry);
			} //end i
		}
		
	}
	
	/*
	* Is the file or folder writeable 
	*/
	function filedir_writeable($filedir){
	        if (is_writable($filedir)){
	        	$color = "green";
	        } else {
	        	$color = "red";
	        }
	
		return $color;
	}
	
	/*
	* Does the folder exist 
	*/
	function isdir($folder){
	        if (is_dir($folder)){
	        	$color = "green";
	        } else {
	        	$color = "red";
	        }
	
		return $color;
	}
	
	/*
	* Does the file exist 
	*/
	function isfile($file){
	        if (is_file($file)){
	        	$color = "green";
	        } else {
	        	$color = "red";
	        }
	
		return $color;
	}
	
	/*
	* Return 1 if the value is green
	*/
	function green( $green ){
		if ($green == "green"){
			return 1;
		} else {
			return 0;
		}
	}
	
	// ----- NO MORE CLASSES OR FUNCTIONS PASSED THIS POINT -----
}
?>


